/*
 * StdinInputStream.java
 * Input stream for a team's standard in.
 *
 * Copyright (c) 2000, 2001 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * @JANOSVM_JVMLIB_LICENSE@
 */

package edu.utah.janosvm.io;

import java.io.InputStream;

/**
 * Input stream for a team's standard in.
 *
 * @author Tim Stack, <a href="mailto:janos-discuss@flux.cs.utah.edu">Utah Janos Team</a>
 */
public class StdinInputStream
    extends InputStream
{

    static
    {
	/* We depend on the IO library */
	System.loadLibrary("io");
    }

    /**
     * Native function that does the actual read from stdin as setup for the
     * current team.
     */
    private native int readInt();

    /**
     * XXX stupid wrapper for the readInt function.
     */
    public int read()
    {
	return this.readInt();
    }

    /**
     * Native function that does a block read from stdin as setup for the
     * current team.
     */
    public native int read(byte b[], int off, int len);

}
