/*
 * ClassPathResource.java
 * Provides access methods to the current team's class path.
 *
 * Copyright (c) 2000, 2001 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * @JANOSVM_JVMLIB_LICENSE@
 */

package edu.utah.janosvm.resources;

import java.io.IOException;

/**
 * Provides access methods to the current team's class path.
 *
 * @see ClassPathSpec
 * @author Tim Stack, <a href="mailto:janos-discuss@flux.cs.utah.edu">Utah Janos Team</a>
 */
public class ClassPathResource
{
    /**
     * Load the file with the given name from the class path.  The file
     * may be anything (not just a .class file).  Note that 'null'
     * is returned if the file is not found, an exception is not thrown.
     *
     * @return The contents of the file as a byte array or null if it wasn't
     * found.
     */
    public static native byte[] loadFile(String name) throws IOException;
}
