/*
 * MemoryResource.java
 * Provides java level access to a team's memory resource.
 *
 * Copyright (c) 2000, 2001 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * @JANOSVM_JVMLIB_LICENSE@
 */

package edu.utah.janosvm.resources;

/**
 * Provides java level access to the current team's memory resource.
 *
 * @author Tim Stack, <a href="mailto:janos-discuss@flux.cs.utah.edu">Utah Janos Team</a>
 */
public final class MemoryResource
{
    /**
     * @return The memory usage, in bytes, for the current team.
     */
    public static native int getUsage();
    
    /**
     * @return The peak usage, in bytes, for the current team.
     */
    public static native int getPeakUsage();
    
    /**
     * @return The maximum allowed memory, in bytes, for this team.
     */
    public static native int getMax();
}
