/*
 * NameSpaceResource.java
 * Provides access methods to the current team's root name space.
 *
 * Copyright (c) 2000, 2001 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * @JANOSVM_JVMLIB_LICENSE@
 */

package edu.utah.janosvm.resources;

/**
 * Provides access methods to the current team's root name space.
 *
 * @author Tim Stack, <a href="mailto:janos-discuss@flux.cs.utah.edu">Utah Janos Team</a>
 */
public class NameSpaceResource
{
    /**
     * Export the named ClassGroup from the current team.  This
     * function looks for a class group with the given name and
     * exports all the classes in that group to the current team.
     * <p>
     * ClassGroups are defined in the JanosVM configuration file.
     * A ClassGroup must be an internally consistent set of
     * classes that can be safely shared between Teams.  That is,
     * all classes referenced by any class in a ClassGroup must
     * be satisfied by that ClassGroup or by a class in another
     * ClassGroup which is also exported to this team.
     * XXX See ### for more documentation on ClassGroups and NameSpaces.
     * <p>
     * XXX define "exports"?
     *
     * @param type The name of a classgroup section in the config file.
     */
    public static native void exportClassGroup(String type);
}
