/*
 * ConfigFile.java
 * Provides basic access to the configuration file.
 *
 * Copyright (c) 2000, 2001 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * @JANOSVM_JVMLIB_LICENSE@
 */

package edu.utah.janosvm.sys;

/**
 * Provides basic access to the configuration file.  A configuration
 * file is a set of string pairs.  Pairs are grouped in 'sections'.
 * The first string in a pair is the 'tag', the second string is the
 * 'value'.  Pairs are looked up by tag.  Multiple pairs may have the
 * same tag, these pairs are ordered into N 'instances', one for each
 * pair.
 * <p>
 * XXX This is a quick hack and should be replaced with something more
 * appropriate.
 *
 * @author Tim Stack, <a href="mailto:janos-discuss@flux.cs.utah.edu">Utah Janos Team</a>
 */
public class ConfigFile
{
    /**
     * Lookup a pair defined in the config file.
     *
     * @param section The pairs section to look up the tag.
     * @param tag The identifier to lookup in the pairs section.
     * @param instance The instance of the tag to select.
     * @return The value of the tag
     */
    public static native String lookup(String section,
				       String tag,
				       int instance);

    /**
     * Lookup the first instance of a pair in the config file.
     *
     * @param section The pairs section to look up the tag.
     * @param tag The identifier to lookup in the pairs section.
     * @return The value of the tag
     */
    public static String lookup(String section, String tag)
    {
	return ConfigFile.lookup(section, tag, 0);
    }
}
