/*
 * ManagedExportable.java
 * Interface declaring that this object needs to be explicitly released
 *
 * Copyright (c) 2000, 2001 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * @JANOSVM_JVMLIB_LICENSE@
 */

package edu.utah.janosvm.sys;

/**
 * Declares that a subclass of Exportable needs to be explicitly
 * released when it is revoked.  This interface is only usefully used
 * when it is implemented by a subclass of Exportable.
 *
 * @author Tim Stack, <a href="mailto:janos-discuss@flux.cs.utah.edu">Utah Janos Team</a>
 * @see Exportable#revoke()
 */
public interface ManagedExportable
{
    void release();
}
