/*
 * ObjectImporter.java
 * Import an ObjectExporter object.
 *
 * Copyright (c) 2000 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * @JANOSVM_JVMLIB_LICENSE@
 */

package edu.utah.janosvm.sys;

/**
 * A handy class for importing generic objects.
 *
 * @see ObjectExporter
 * @author Tim Stack, <a href="mailto:janos-discuss@flux.cs.utah.edu">Utah Janos Team</a>
 */
public class ObjectImporter
    extends Importable
{
    public ObjectImporter()
    {
    }

    /**
     * @return The object held by the ObjectExporter.
     */
    public synchronized Object getObject()
    {
	ObjectExporter oe = (ObjectExporter)this.get();
	Object retval = null;
	
	if( oe != null )
	{
	    retval = oe.getObject();
	}
	return retval;
    }

    /**
     * Revoke the import.
     */
    public void revoke()
    {
	super.revoke();
    }
}
