/*
 * PersistentExport.java
 * Indicates an object is kept alive even though it isn't imported.
 *
 * Copyright (c) 2000, 2001 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * @JANOSVM_JVMLIB_LICENSE@
 */

package edu.utah.janosvm.sys;

/**
 * Indicates an Exportable is to be kept alive even though it isn't
 * imported by anyone at the moment.  Only useful when implemented
 * by a subclass of Exportable.
 * <p>
 * XXX compare with RemoteTeam.anchorObject(Object)
 * <p>
 * XXX won't all exportables be kept alive in the Team's export table?
 *
 * @see TemporaryExport
 * @see Exportable
 * @author Tim Stack, <a href="mailto:janos-discuss@flux.cs.utah.edu">Utah Janos Team</a>
 */
public interface PersistentExport
{
}
