/*
 * SegmentationFaultError.java
 * Error thrown when the write barrier needs to complain about a bad cross
 * team pointer.
 *
 * Copyright (c) 2000, 2001 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * @JANOSVM_JVMLIB_LICENSE@
 */

package edu.utah.janosvm.sys;

/**
 * Indicates that an invalid cross-process pointer was dereferenced.
 * This Error is only thrown by the write-barrier code.
 *
 * @author Tim Stack, <a href="mailto:janos-discuss@flux.cs.utah.edu">Utah Janos Team</a>
 */
public final class SegmentationFaultError
    extends Error
{
    public SegmentationFaultError()
    {
	super();
    }

    public SegmentationFaultError(String msg)
    {
	super(msg);
    }
}
