/*
 * TemporaryExport.java
 * Indicates that an exported object is only alive as long as it is imported.
 *
 * Copyright (c) 2000, 2001 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * @JANOSVM_JVMLIB_LICENSE@
 */

package edu.utah.janosvm.sys;

/**
 * Indicate that an exported object is only alive as long as it is
 * imported by someone.  Only useful when implemented by a subclass
 * of Exportable.
 *
 * @see PersistentExport
 * @see Exportable
 * @see Exportable#unsubscribe(Importable)
 * @author Tim Stack, <a href="mailto:janos-discuss@flux.cs.utah.edu">Utah Janos Team</a>
 */
public interface TemporaryExport
{
}
