/*
 * Copyright (c) 2000, 2001, 2002 The University of Utah. All rights reserved.
 *
 * This file is licensed under the terms of the GNU Public License.  
 * See the file "license.terms" for restrictions on redistribution 
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 * Contributed by the Flux Research Group at the University of Utah.
 * Authors: Godmar Back, Leigh Stoller
 */

#ifndef __i386_nodeos_md_h
#define __i386_nodeos_md_h

#include "i386/common.h"
#include "i386/threads.h"

/*
 * Undefine stack pointer offset, we don't need it
 */
#undef	SP_OFFSET

#if defined(TRANSLATOR)
#include "jit-md.h"
#endif

#define KAFFE_ON_NODEOS

/*
 * Replace Kaffe's 'main' with 'originalKaffeMain'.
 * nodeos/md.c has a new main() replacement.
 */
#ifndef NODEOS_IN_MD_C
#define main originalKaffeMain
#endif

int originalKaffeMain(int argc, char** argv);

/*
 * Insert a call to nodeos_main_md() in Kaffe's main
 * via the MAIN_MD macro.
 */
void nodeos_main_md(void);
#define MAIN_MD	nodeos_main_md()

/*
 * Provide a default classpath based on the CLASSPATH read
 * out of a file
 */
extern char* kaffe_nodeos_classpath;
#define DEFAULT_CLASSPATH kaffe_nodeos_classpath

/*
 * Parse nodeos-specific command line options.
 */
int nodeos_option_parsefunc(char **argv, int *i);
#define MD_OPTION_PARSEFUNC nodeos_option_parsefunc

/*
 * The number of threads to preallocate and place in the root domain's thread
 * pool.  Java objects are then paired with these threads by the
 * jthread_createfirst function.
 */
#define ROOT_DOMAIN_THREAD_CT 3
struct _jthread;
extern struct _jthread *an_jthreadlist[ROOT_DOMAIN_THREAD_CT];

/*
 * Main thread uses default stacksize.
 */
#define MAINSTACKSIZE	threadStackSize
#endif
