/*
 * janosvm.c
 * Perform any additional initialization for janosvm
 *
 * Copyright (c) 2000, 2001 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * This file is licensed under the terms of the GNU Public License.  
 * See the file "license.terms" for restrictions on redistribution 
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */

#include "gtypes.h"
#include "external.h"
#include "module.h"
#include "janosvm.h"

/** Module declarations **/
static int initJanosVMModule(int stage);

module_t janosvmModule = {
	"janosvm",
	0,
	initJanosVMModule,
	0,
	0
};

/** Module functions **/
int initJanosVMModule(int stage)
{
	int retval = 0;

	if( findLibrary(JANOSVMLIBRARY) >= 0 )
		retval = 1;
	else
		fprintf(stderr, "Couldn't find `lib%s'.\n", JANOSVMLIBRARY);
	return( retval );
}

void edu_utah_janosvm_sys_VMInstance_shutdown(void)
{
	EXIT(0);
}
