/*
 * jarFileType.h
 * Class path fileTypeHandler for JAR files
 *
 * Copyright (c) 2000 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * This file is licensed under the terms of the GNU Public License.  
 * See the file "license.terms" for restrictions on redistribution 
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */

#ifndef _jar_file_type_h
#define _jar_file_type_h

/*
 * This module is a class path fileTypeHandler that handles JAR files.
 */

#include "classPath.h"

/*
 * A jarClassPathEntry is used to store extra information needed to track JAR
 * file entries.
 *
 * `entry' - A classPathEntry header.
 * `jar' - The JAR file object that corresponds to the JAR for this entry.
 */
typedef struct _jarClassPathEntry {
	classPathEntry entry;
	jarFile *jar;
} jarClassPathEntry;

/*
 * AddModule: jarFileTypeModule
 *   ModuleDependency: classPathModule.handlers
 *   Comment: Install our fileTypeHandler so classPath can use it
 */

#endif
