/*
 * memResource-inline.h
 * Inline functions for the memory resource
 *
 * Copyright (c) 2000, 2001 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * This file is licensed under the terms of the GNU Public License.  
 * See the file "license.terms" for restrictions on redistribution 
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */

#ifndef _mem_resource_inline_h
#define _mem_resource_inline_h

/*
 * Don't #include this directly, just #include memResource.h
 */

/*
 * Get the garbage collector object for a given team.
 */
KAFFE_INLINE
void *teamCollector(struct _jteam *jt)
{
	void  *retval;
	memResourceClient *mrc;
	
	mrc = (memResourceClient*)
		getTeamInternalResource(jt, &metalMemResource.link);
	retval = mrc->collector;
	
	ensure(retval != 0);

	return( retval );
}
/*
 * Get the garbage collector object for the current team.
 */
KAFFE_INLINE
void *currentCollector(void)
{
	void *retval;

	retval = teamCollector(0);
	
	ensure(retval != 0);
	
	return( retval );
}

#endif /* _mem_resource_inline_h */
