/*
 * heyHandlers.h
 * Contains any of jsihey's jsiHandlers.
 *
 * Copyright (c) 2000 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * This file is licensed under the terms of the GNU Public License.  
 * See the file "license.terms" for restrictions on redistribution 
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include <jsi/jsi.h>

#include "heyHandlers.h"

jsiNamedHandler *heyHandlerList;

static jsiFileHandler jsiStdinHandler;
static jsiHandlerFunctions jsiStdinFunctions;
static jsiFileHandler jsiStdoutHandler;
static jsiHandlerFunctions jsiStdoutFunctions;
static jsiFileHandler jsiStderrHandler;
static jsiHandlerFunctions jsiStderrFunctions;

void installHeyHandlers(void)
{
	/* Install the stdio handlers provided by JSI */
	jsiInitNamedHandler(&jsiStdinHandler.handler,
			    JNA_Name, "in",
			    JNA_Functions, &jsiStdinFunctions,
			    JNA_HandleMessage, jsiHandleFileIOMessage,
			    JNA_ResolveSpecifier, jsiResolveFileIOSpecifier,
			    JNA_TAG_DONE);
	jsiStdinHandler.fd = 0; // stdin
	jsiStdinHandler.flags = FHF_READ;
	jsiInstallHandler(&heyHandlerList, &jsiStdinHandler.handler);
	jsiInitNamedHandler(&jsiStdoutHandler.handler,
			    JNA_Name, "out",
			    JNA_Functions, &jsiStdoutFunctions,
			    JNA_HandleMessage, jsiHandleFileIOMessage,
			    JNA_ResolveSpecifier, jsiResolveFileIOSpecifier,
			    JNA_TAG_DONE);
	jsiStdoutHandler.fd = 1; // stdout
	jsiStdoutHandler.flags = FHF_WRITE;
	jsiInstallHandler(&heyHandlerList, &jsiStdoutHandler.handler);
	jsiInitNamedHandler(&jsiStderrHandler.handler,
			    JNA_Name, "err",
			    JNA_Functions, &jsiStderrFunctions,
			    JNA_HandleMessage, jsiHandleFileIOMessage,
			    JNA_ResolveSpecifier, jsiResolveFileIOSpecifier,
			    JNA_TAG_DONE);
	jsiStderrHandler.fd = 2; // stderr
	jsiStderrHandler.flags = FHF_WRITE;
	jsiInstallHandler(&heyHandlerList, &jsiStderrHandler.handler);
}
