/*
 * jsi.h
 * JanosVM Scripting Interface functions
 *
 * Copyright (c) 2000 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * This file is licensed under the terms of the GNU Public License.  
 * See the file "license.terms" for restrictions on redistribution 
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */

#ifndef _jsi_plex_udp_h
#define _jsi_plex_udp_h

#include "jsiPlexLink.h"

typedef struct _jsiPlexUDPIn {
	jsiPlexInLink link;
	int fd;
	struct {
		jsiPlexLinkPacket data;
#define		JSI_PLEX_UDP_MAX_BODY_SIZE 1024
		char body[JSI_PLEX_UDP_MAX_BODY_SIZE];
	} recvBuffer;
} jsiPlexUDPIn;

typedef struct _jsiPlexUDPOut {
	jsiPlexOutLink link;
	struct _jsiPlexUDPOut *next;
	struct sockaddr_in dest;
} jsiPlexUDPOut;

typedef struct _jsiPlexUDP {
	jsiPlexLink link;
	int fd;
	jsiPlexUDPOut *outLinks;
} jsiPlexUDP;

jsiPlexLink *jsiCreatePlexUDP(void);

#endif
