
KAFFE_INLINE
void _lockMutex(iLock** lkp, void* where)
{
	uintp val;

	val = (uintp)*lkp;

	if (val == 0) {
		if (!COMPARE_AND_EXCHANGE(lkp, 0, (iLock*)where)) {
			slowLockMutex(lkp, where);
		}
	}
	else if (val - (uintp)where > 1024) {
		/* XXX count this in the stats area */
		slowLockMutex(lkp, where);
	}
	
	ensure(jthread_current());
	ensure(jthread_get_data(jthread_current()));
	ensure(jthread_get_data(jthread_current())->freeLock != 0);
}

/*
 * Unlock a mutex - try to do this quickly but if we failed then
 * we've got contention so fall back on a slow lock.
 */
KAFFE_INLINE
void _unlockMutex(iLock** lkp, void* where)
{
	uintp val;

	val = (uintp)*lkp;

	if ((val & 1) != 0) {
		slowUnlockMutex(lkp, where);
	}
	else if ((val == (uintp)where) /* XXX squirrely bit */
		&& !COMPARE_AND_EXCHANGE(lkp, (iLock*)where, LOCKFREE)) {
		slowUnlockMutex(lkp, where);
	}
	
	ensure(jthread_get_data(jthread_current())->freeLock != 0);
}
