/*
 * machineDependent.c
 * Perform any machine dependent initialization
 *
 * Copyright (c) 2000 University of Utah and the Flux Group.
 * All rights reserved.
 *
 * This file is licensed under the terms of the GNU Public License.
 * See the file "license.terms" for information on usage and redistribution
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 * Contributed by the Flux Research Group, Department of Computer Science,
 * University of Utah, http://www.cs.utah.edu/flux/
 */

#include "module.h"

/** Module declarations **/
static int initMachineDependentModule(int stage);

module_t machineDependentModule = {
	"machineDependent",
	0,
	initMachineDependentModule,
	0,
	0
};

/** Module functions **/
int initMachineDependentModule(int stage)
{
	/* Run machine dependent code, if there is any */
#if defined(INIT_MD)
	INIT_MD();
#endif
	return( 1 );
}
