/*
 * Copyright (c) 1999, 2000, 2001 The University of Utah.  All rights reserved.
 *
 * This file is licensed under the terms of the GNU Public License.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file.
 *
 * Contributed by the Flux Research Group at the University of Utah.
 * Authors: Godmar Back, Leigh Stoller, Patrick Tullmann
 */

/*
 * jthread creation functions
 */

#ifndef anjthread_create_h
#define anjthread_create_h

#include <stdarg.h>

#include "anjthread_types.h"

/*
 * create a thread with a given priority
 */
struct _jthread*
jthread_create(unsigned int pri, 	/* initial priority */
	       void (*func)(void *),	/* start function */
	       int daemon, 		/* is this thread a daemon? */
	       void *jlThread, 		/* cookie for this thread */
	       size_t threadStackSize);	/* stack size to be allocated */

void
anjthread_createpartialthread(struct _jthread* tid,
			      void *jlThread,
			      size_t threadStackSize);

void
anjthread_enterkaffe(void *arg, jmethodID runmethod, ...);

void
anjthread_enterkaffe_c(void);

void
anjthread_exitkaffe_c(void);

/* 
 * XXX This function is provided by ../../thread.c.  But we don't 
 * want to include ../../../thread.h.  Including the prototype here
 * (in a header file)
 * will force a warning/error if the prototype in thread.h ever
 * changes.
 */
struct Hjava_lang_Thread;
struct Hjava_lang_Object;
void
threadEnterVM_valist(struct Hjava_lang_Thread* tid,
		     struct Hjava_lang_Object* obj,
		     jmethodID runmethod,
		     va_list argptr);

#endif /* anjthread_create_h */
