/*
 * Copyright (c) 1999, 2000, 2001 The University of Utah.  All rights reserved.
 *
 * This file is licensed under the terms of the GNU Public License.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file.
 *
 * Contributed by the Flux Research Group at the University of Utah.
 * Authors: Godmar Back, Leigh Stoller, Patrick Tullmann
 */
/*
 * jthread debug functions
 */

#include "anjthread_types.h"
#include "anjthread_types_priv.h"
#include "anjthread_globals.h"
#include "anjthread_debug.h"

/*
 * dump info on all live threads
 */
void
/* ARGSUSED */
jthread_dumplivethreads(int s)
{
        jthread_t tid;
        for (tid = jthread_liveThreads; tid != NULL; tid = tid->nextlive) {
		jthread_dumpthreadinfo(tid);
	}
}


/*
 * Print info about a given jthread to stderr
 */
void 
jthread_dumpthreadinfo(jthread_t tid)
{
	fprintf(stderr, "jthread %p native %p status %s flags={%s%s%s%s}", 
		tid, &tid->native_thread,
		tid->status == JTHREAD_STATUS_NEWBORN ? "NEWBORN" :
		tid->status == JTHREAD_STATUS_INNODEOS? "INNODEOS":
		tid->status == JTHREAD_STATUS_RUNNING ? "RUNNING" :
		tid->status == JTHREAD_STATUS_DYING   ? "DYING"   :
		tid->status == JTHREAD_STATUS_DEAD    ? "DEAD"    : "???",
		(tid->flags&JTHREAD_FLAG_ROOTTHREAD)?"RootThread,":"",
		(tid->flags&JTHREAD_FLAG_DYING)?"Dying,":"",
		(tid->flags&JTHREAD_FLAG_INTR_SLAUGHTER)?"SlaughterInterrupt,":"",
		(tid->flags&JTHREAD_FLAG_INTR_STOP)?"StopInterrupt,":""
		);
}
