/*
 * Copyright (c) 1999, 2000 The University of Utah.  All rights reserved.
 *
 * This file is licensed under the terms of the GNU Public License.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file.
 *
 * Contributed by the Flux Research Group at the University of Utah.
 * Authors: Godmar Back, Leigh Stoller, Patrick Tullmann
 */

/*
 * end-of-life functions on jthreads
 */

#ifndef anjthread_end_h
#define anjthread_end_h

#include "config.h"
#include "config-std.h"

/*
 * Have the current thread die by throwing a ThreadDeath
 * exception.
 */
void jthread_die(void) __NORETURN__;

/*
 * Have the current thread exit.  It will remove its jthread
 * structure from various internal lists.  The underlying
 * thread object will exit (so it can never be scheduled
 * again.)
 */
void 	jthread_exit(void) __NORETURN__;

/*
 * Have the current thread do real internal cleanup.  (Called
 * by jthread_exit and the jthread interrupt handlers).
 * Calls underlying an_thread_exit();
 */
void	jthread_exit_internal(struct _jthread* tid, bool doFinalizer) __NORETURN__;

/* 
 * Destroy the given jthread structure.  The given thread
 * must be dead and buried.
 */
void	jthread_destroy(struct _jthread * jtid);


#endif /* anjthread_end_h */
