

/*
 * anjthread_globals.h
 *
 * Global variables for the NodeOS jthread implementation.
 */

#ifndef anjthread_globals_h
#define anjthread_globals_h

#include "config.h"
#include <nodeos/an_mutex.h>

extern int	jthread_talive; 		/* number of threads alive */
extern int	jthread_tdaemon;		/* number of daemons alive */

/* 
 * list of all live threads 
 */
extern struct _jthread* jthread_liveThreads;	

/* 
 * static lock to protect jthread_liveThreads etc. 
 */
an_mutex_t jthread_creationLock;

extern void*	(*jthread_allocator)(size_t); 	/* XXX deprecated */
extern void	(*jthread_deallocator)(void*);	/* XXX deprecated */
extern void	(*jthread_destructor1)(void*);	/* call when a thread exits */
extern void	(*jthread_onstop)(void);        /* call when a thread is stopped */

#endif /* anjthread_globals_h */
