/*
 * Copyright (c) 2000 The University of Utah.  All rights reserved.
 *
 * This file is licensed under the terms of the GNU Public License.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file.
 */

#ifndef anjthread_lock_inline_h
#define anjthread_lock_inline_h

ANJTHREAD_INLINE void
jthread_spinon(void *addr)
{
	an_thread_setprio(an_thread_current(), AN_THREAD_PRIO_EXCLUSIVE);
}

ANJTHREAD_INLINE void
jthread_spinoff(void *addr)
{
	an_thread_setprio(an_thread_current(), AN_THREAD_PRIO_NORMAL);
}



ANJTHREAD_INLINE void 
jmutex_initialise(jmutex *lock)
{
	void *p;
	p = an_mutex_create(lock);
	assert(p == lock);
}

ANJTHREAD_INLINE void
jmutex_lock(jmutex *lock)
{
	an_mutex_lock(lock);
}

ANJTHREAD_INLINE void
jmutex_unlock(jmutex *lock)
{
	an_mutex_unlock(lock);
}

ANJTHREAD_INLINE void
jmutex_destroy(jmutex *lock)
{
	an_mutex_destroy(lock);
}

ANJTHREAD_INLINE void
jcondvar_initialise(jcondvar *cv)
{
	void *p;
	p = an_cond_create(cv);
	assert(p == cv);
}

ANJTHREAD_INLINE void
jcondvar_signal(jcondvar *cv, jmutex *lock)
{
	an_cond_signal(cv);
}

ANJTHREAD_INLINE void
jcondvar_destroy(jcondvar *cv)
{
	an_cond_destroy(cv);
}


#endif /* anjthread_lock_inline_h */
