/*
 * Copyright (c) 1999, 2000 The University of Utah.  All rights reserved.
 *
 * This file is licensed under the terms of the GNU Public License.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file.
 *
 * Contributed by the Flux Research Group at the University of Utah.
 * Authors: Godmar Back, Leigh Stoller, Patrick Tullmann
 */

/*
 * jthread "status" functions.  Let you query thread state, stack info, etc.
 */

#ifndef anjthread_status_h
#define anjthread_status_h

#include "anjthread_types.h"

bool jthread_killed(void);

int jthread_alive(struct _jthread* tid);

int jthread_extract_stack(struct _jthread* jtid,
			  void **used_from, unsigned *used_len,
			  void **free_from, unsigned *free_len);

int jthread_stackcheck(int need);

int jthread_frames(struct _jthread* thread);

#include "anjthread_inline.h"
#include "anjthread_status-inline.h"

#endif /* anjthread_status_h */
