/*
 * Copyright (c) 1999, 2000, 2001 The University of Utah.  All rights reserved.
 *
 * This file is licensed under the terms of the GNU Public License.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file.
 *
 * Contributed by the Flux Research Group at the University of Utah.
 * Authors: Godmar Back, Leigh Stoller, Patrick Tullmann
 */

#ifndef anjthread_types_h_
#define anjthread_types_h_

#include <nodeos/an_thread.h>
#include <nodeos/an_mutex.h>
#include <nodeos/an_cond.h>
#include <nodeos/an_fs.h>

struct Hjava_lang_Thread;
struct Hjava_lang_Runnable;
struct _exceptionFrame;
struct _jthread;

typedef an_mutex_t jmutex;
typedef an_cond_t jcondvar;

#define JMUTEX_STATIC_INITIALIZER { { { { NULL } } } }
#define JCONDVAR_STATIC_INITIALIZER { { { NULL } , { { NULL } } } }

typedef void (*jthread_exchandler_t)(struct _exceptionFrame*);

#endif /* anjthread_types_h_ */
