/*
 * Copyright (c) 1999, 2000 The University of Utah.  All rights reserved.
 *
 * This file is licensed under the terms of the GNU Public License.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file.
 *
 * Contributed by the Flux Research Group at the University of Utah.
 * Authors: Godmar Back, Leigh Stoller, Patrick Tullmann
 */

/*
 * live jthread walk functions
 */

#ifndef anjthread_walk_h
#define anjthread_walk_h

#include "anjthread_types.h"

/*
 * walk all live threads, and invoke `func', passing in their cookie
 * this is used with `func' set to walkMemory
 */
void 	jthread_walkLiveThreads(void *collector, void (*func)(void *c, struct _jthread* jtid, void *mem));

/*
 * Walk all the live threads.  Takes the internal threadLock.  
 */
void 	jthread_walk_jthreads(void *collector, void (*func)(void *c, struct _jthread* jtid));

#endif /* anjthread_walk_h */
