/*
 * journal.h
 *
 * Copyright (c) 2001 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * This file is licensed under the terms of the GNU Public License.  
 * See the file "license.terms" for restrictions on redistribution 
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */

#ifndef _journal_h
#define _journal_h

#include "native.h"

typedef struct _journalEntry {
	struct Hjava_lang_Object base;
	struct _journalEntry *next;
	void *id;
} journalEntry;

typedef struct _journal {
#define JOURNAL_ENTRY_COUNT 15
	journalEntry *entries[JOURNAL_ENTRY_COUNT];
} journal;

void initJournal(journal *j);
void addJournalEntry(journal *j, journalEntry *je);
void remJournalEntry(journal *j, void *id);
journalEntry *findJournalEntry(journal *j, void *id);

#endif
