/*
 * gmon_bsd.c
 * Definitions for the BSD gmon file format
 *
 * Copyright (c) 2000 University of Utah and the Flux Group.
 * All rights reserved.
 *
 * This file is licensed under the terms of the GNU Public License.
 * See the file "license.terms" for information on usage and redistribution
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 * Contributed by the Flux Research Group, Department of Computer Science,
 * University of Utah, http://www.cs.utah.edu/flux/
 */
#ifndef _gmon_bsd_h
#define _gmon_bsd_h

/*
 * BSD header format
 */
struct bsd_gmonhdr {
        u_long  lpc;            /* base pc address of sample buffer */
        u_long  hpc;            /* max pc address of sampled buffer */
        int     ncnt;           /* size of sample buffer (plus this header) */
        int     version;        /* version number */
        int     profrate;       /* profiling clock rate */
        int     spare[3];       /* reserved */
        /* XXX should record counter size and density */
};
#define BSD_GMONVERSION     0x00051879

#endif
