/*
 * StdOutputStream.c
 * Native functions for edu/utah/janosvm/io/StdOutputStream.java
 *
 * Copyright (c) 2000 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * This file is licensed under the terms of the GNU Public License.  
 * See the file "license.terms" for restrictions on redistribution 
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 * XXX move this code into kaffe/janosvm/<something>
 */

#include "config.h"
#include "config-std.h"
#include "config-io.h"
#include "config-mem.h"
#include "files.h"
#include "defs.h"
#include "jsyscall.h"
#include "edu_utah_janosvm_io_StdOutputStream.h"
#include "../../../kaffe/kaffevm/support.h"
#include "../../../kaffe/kaffevm/stringSupport.h"
#include "../../../kaffe/janosvm/stdioResource.h"

void
edu_utah_janosvm_io_StdOutputStream_close(
	struct Hedu_utah_janosvm_io_StdOutputStream *ps)
{
}

void
edu_utah_janosvm_io_StdOutputStream_flush(
	struct Hedu_utah_janosvm_io_StdOutputStream *ps)
{
	stdioFlush(ps->kind);
}

void
edu_utah_janosvm_io_StdOutputStream_write(
	struct Hedu_utah_janosvm_io_StdOutputStream *ps,
	HArrayOfByte *arr,
	jint off,
	jint len)
{
	if( arr )
	{
		char *buffer = (char *)ARRAY_DATA(arr);
		int size = ARRAY_SIZE(arr);

		/* XXX */
		stdioWrite(ps->kind, &buffer[off], MIN(len, size));
	}
}

void
edu_utah_janosvm_io_StdOutputStream_writeInt(
	struct Hedu_utah_janosvm_io_StdOutputStream *ps, jint x)
{
	stdioPrint(ps->kind, "%c", (char)x);
}
