/*
 * kaffe.management.Classpath.c
 *
 * Copyright (c) 1998
 *	Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */

#include "config.h"
#include "config-std.h"
#include <native.h>
#include "../../../kaffe/kaffevm/gtypes.h"
#include "../../../kaffe/kaffevm/support.h"
#include "../../../kaffe/kaffevm/stringSupport.h"
#include "../../../kaffe/janosvm/classPath.h"
#include "kaffe_management_Classpath.h"

/*
 * Add a JAR/ZIP to the classpath.
 */
void
kaffe_management_Classpath_add0(struct Hjava_lang_String* str)
{
	char *s;

	s = checkPtr(stringJava2C(str));
	addClassPath((classPathClient *)
		getTeamInternalResource(0, &metalClassPathResource.link),
		s, 0);
	KFREE(s);
}

/*
 * Prepend a JAR/ZIP to the classpath.
 */
void
kaffe_management_Classpath_prepend0(struct Hjava_lang_String* str)
{
	classPathClient *cpc;
	char *s;

	s = checkPtr(stringJava2C(str));
	cpc = (classPathClient *)
		getTeamInternalResource(0, &metalClassPathResource.link);
	addClassPath(cpc, s,
		     cpc->entries.data[0].priority + 1);
	KFREE(s);
}

