/*
 * NameSpaceResource.java
 * Emulates the services provided by the real class.
 *
 * Copyright (c) 2000, 2001 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * This file is licensed under the terms of the GNU Lesser 
 * General Public License.
 * 
 * See the file "license-lesser.terms" for information on 
 * usage and redistribution of this file.
 */

package edu.utah.janosvm.resources;

/**
 * Provides access methods to the current team's root name space.
 */
public class NameSpaceResource
{
    /**
     * Export a set of classes described by the given class group type name.
     */
    public static void exportClassGroup(String type)
	throws ClassNotFoundException,
	       ClassGroupNotFoundException,
	       InvalidClassGroupException
    {
	System.err.println("Cannot export class groups in emulation.");
    }
    
    public static Class loadTeamClass(String className)
	throws ClassNotFoundException
    {
	return Class.forName(className);
    }

    public static Class loadTeamClass(String className, boolean initialize)
	throws ClassNotFoundException
    {
	// XXX ignores initialize
	return Class.forName(className);
    }
}
