/*
 * NativeSpec.java
 * Resource specification for a team's native library path.
 *
 * Copyright (c) 2001 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * This file is licensed under the terms of the GNU Lesser 
 * General Public License.
 * 
 * See the file "license-lesser.terms" for information on 
 * usage and redistribution of this file.
 */

package edu.utah.janosvm.resources;

/**
 * Specification for the native library resource.
 *
 * @see NativeResource
 * @author Tim Stack, <a href="mailto:janos-discuss@flux.cs.utah.edu">Utah Janos Team</a>
 */
public final class NativeSpec
    extends ResourceSpec
{
    public NativeSpec(String entries[])
    {
    }
    
    public int getPathCount()
    {
	return 0;
    }

    public String getPath(int index)
    {
	return null;
    }

    public Object clone()
    {
	return new NativeSpec(null);
    }

    public static NativeSpec current()
    {
	return new NativeSpec(null);
    }
}
