/*
 * VMInstance.java
 * Emulates the services provided by the real class.
 *
 * Copyright (c) 2000, 2001 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * This file is licensed under the terms of the GNU Lesser 
 * General Public License.
 * 
 * See the file "license-lesser.terms" for information on 
 * usage and redistribution of this file.
 */

package edu.utah.janosvm.sys;

public class VMInstance
{
    public static void crash()
    {
	System.err.println("Crash not supported in the emulation library");
    }
    
    public static void panic(String msg)
    {
	System.out.println("Panic: " + msg);
	shutdown();
    }

    public static void panic(String msg, Throwable th)
    {
	System.err.println("Panic: " + msg);
	th.printStackTrace(System.err);
	shutdown();
    }
    
    /**
     * Shutdown the VM.
     */
    public static void shutdown()
    {
	System.exit(0);
    }

    /**
     * Get the name of this VM instance.
     */
    public static String getName()
    {
	System.err.println("Not supported in the emulation library");
	return "";
    }
}
