/*
 * gak_ARPHandler.c
 *
 * Copyright (c) 2000, 2001 The University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is licensed under the terms of the GNU Public License.  
 * See the file "license.terms" for restrictions on redistribution 
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */

#include <stdio.h>

#include <native.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <nodeos/an_chan.h>
#include <nodeos/lib/arplib.h>

void
edu_utah_janos_services_arp_ARPHandler_init(void)
{
	int rc;
	rc = arp_init();
	assert(rc == 0);
}

void
edu_utah_janos_services_arp_ARPHandler_config_iface(jint iface,
						    HArrayOfByte* jipaddr)
{
	struct in_addr ipaddr;
	int rc;

	ipaddr.s_addr = *((int*)(unhand_array(jipaddr)));
	rc = arp_config_iface(iface, &ipaddr);
	assert(rc == 0);/* XXX */
}

jint
edu_utah_janos_services_arp_ARPHandler_arpfor(jint iface,
					      HArrayOfByte* jipaddr,
					      HArrayOfByte* ethaddr)
{
	struct in_addr ipaddr;
	int rc;
	
	ipaddr.s_addr = *((int*)(unhand_array(jipaddr)));

	rc = arp_arpfor(iface, &ipaddr,
			(unsigned char *)unhand_array(ethaddr));
	return rc;
}

void
edu_utah_janos_services_arp_ARPHandler_find_ethaddr(jint iface,
						    HArrayOfByte* myEthAddr)
{
	an_ethaddrspec_t spec;
	int rc;
	
	rc = arp_find_ethaddr(iface, &spec);
	memcpy(unhand_array(myEthAddr), spec.saddr, 6);
	assert(rc == 0);/* XXX */
}

void
edu_utah_janos_services_arp_ARPHandler_destroy(void)
{
	int rc;
	rc = arp_exit();
	assert(rc == 0);
}
