/*
 * jsi.h
 * JanosVM Scripting Interface functions
 *
 * Copyright (c) 2000, 2001, 2002 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * This file is licensed under the terms of the GNU Public License.  
 * See the file "license.terms" for restrictions on redistribution 
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */

#ifndef _jsi_plex_udp_h
#define _jsi_plex_udp_h

#include <jsi/jsiPlexLink.h>

#include "moabglue.h"

typedef struct _jsiPlexUDPIn {
	jsiPlexInLink link;
	int users;
	an_chan_t inChannel;
	an_demuxkey_t demux;
#define JSI_PLEX_UDP_RECV_QUEUE_SIZE 8
	an_pbuf_t pbufs[JSI_PLEX_UDP_RECV_QUEUE_SIZE];
	struct {
		jsiPlexLinkPacket data;
#define		JSI_PLEX_UDP_MAX_BODY_SIZE 1024
		char body[JSI_PLEX_UDP_MAX_BODY_SIZE];
	} recvBuffer;
} jsiPlexUDPIn;

typedef struct _jsiPlexUDPOut {
	jsiPlexOutLink link;
	struct _jsiPlexUDPOut *next;
	jsiPlexUDPIn *pui;
	int ipAddr; // Network order
	unsigned short udpPort; // Network order
	unsigned short srcPort;
	an_chan_t outChannel;
	an_pbuf_t pbuf;
} jsiPlexUDPOut;

struct _iLock;

typedef struct _jsiPlexUDP {
	jsiPlexLink link;
	struct _iLock *lock;
	int ipAddr;
	unsigned short outPort;
	unsigned short inPort;
	int ifNumber;
	jsiPlexUDPOut *outLinks;
} jsiPlexUDP;

jsiPlexLink *jsiCreatePlexUDP(void);

#endif
