/*
 * moab_IPAddressSpec.c
 *
 * Copyright (c) 2000, 2001 The University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is licensed under the terms of the GNU Public License.  
 * See the file "license.terms" for restrictions on redistribution 
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */

#include <stdlib.h>
#include <sys/types.h>
#include <netinet/in.h>

#include <nodeos/impl/an_impl.h>

#include "moabglue.h"
#include "edu_utah_janos_nodeos_moab_IPAddressSpec.h"

#include <misc/stringParsing.h>

void edu_utah_janos_nodeos_moab_IPAddressSpec_init(struct Hedu_utah_janos_nodeos_moab_IPAddressSpec *this,
						   struct Hjava_lang_String *jAddr)
{
	char *addr = stringJava2C(jAddr);
	parsedString srcAddr, destAddr;
	int srcPort, destPort;
	an_chanaddr_t *ca;

	ca = NATIVE_ADDRSPEC(
		(struct Hedu_utah_janos_nodeos_moab_ChannelAddressSpec *)this);
	if( parseString(addr,
			SPO_NonEmptyString, &srcAddr,
			SPO_Cond, ":",
			  SPO_Integer, &destPort,
			  SPO_Cond, ":",
			    SPO_NonEmptyString, &destAddr,
			    SPO_Cond, ":",
			      SPO_Integer, &srcPort,
			      SPO_End,
			    SPO_End,
			  SPO_End,
			SPO_End) )
	{
		ca->udp4.daddr = htonl(INADDR_ANY); // XXX
		ca->udp4.saddr = htonl(INADDR_ANY); // XXX
		ca->udp4.dport = htons(destPort);
		ca->udp4.sport = 0; // XXX
	}
	gc_free(addr);
}

Hjava_lang_String *
edu_utah_janos_nodeos_moab_IPAddressSpec_getSource(struct Hedu_utah_janos_nodeos_moab_IPAddressSpec *this)
{
	/* XXX */
	return( NULL );
}

Hjava_lang_String *
edu_utah_janos_nodeos_moab_IPAddressSpec_getDestination(struct Hedu_utah_janos_nodeos_moab_IPAddressSpec *this)
{
	/* XXX */
	return( NULL );
}
