/*
 * moab_Node.c
 *
 * Copyright (c) 2000, 2001, 2002 The University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is licensed under the terms of the GNU Public License.  
 * See the file "license.terms" for restrictions on redistribution 
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */

#include <stdlib.h>

#include <nodeos/an_info.h>

#include "../../../../kaffe/kaffevm/gtypes.h"
#include "../../../../kaffe/kaffevm/stringSupport.h"
#include "../../../../kaffe/kaffevm/classMethod.h"

#include "java_lang_Throwable.h"

#include "moabglue.h"

/* Extras in src/pq/pq.c */
extern void	pq_disable(void), pq_enable(void);

/* Extras in OSKit */
extern void	stride_scheduler_disable(void);
extern void	stride_scheduler_enable(void);

static inline void
printStr(struct Hjava_lang_String* msg, int donewline)
{
	int i;
	char buf[STRING_SIZE(msg)+2];

	i = 0;
	while (i < STRING_SIZE(msg))
	{
		buf[i] = (char)(STRING_DATA(msg)[i]);
		i++;
	}

	if (donewline)
		buf[i++] = '\n';

	buf[i] = '\0';
	write(1, buf, i);
}

void edu_utah_janos_nodeos_moab_Node_println(struct Hjava_lang_String* msg)
{
	printStr(msg, 1);
}

void edu_utah_janos_nodeos_moab_Node_print(struct Hjava_lang_String* msg)
{
	printStr(msg, 0);
}

extern void printStackTrace(Hjava_lang_Throwable*, struct Hjava_lang_Object*, int);

void edu_utah_janos_nodeos_moab_Node_printStackTrace(Hjava_lang_Throwable* th)
{
	if (th)
	{
		Hjava_lang_String* msgStr;

		msgStr = unhand(th)->message;
		if (msgStr)
		{
			char *msg;

			msg = stringJava2C(msgStr);
			printf("%s: %s\n",
				CLASS_CNAME(OBJECT_CLASS(&th->base)),
				msg);
			gc_free(msg);
		}
		else
		{
			printf("%s: \n",
				CLASS_CNAME(OBJECT_CLASS(&th->base)));
		}
		printStackTrace(th, NULL, 1);
	}
	else
	{
		printf("Null exception passed to moab_Node.printStackTrace()\n");
	}
}

void edu_utah_janos_nodeos_moab_Node_fatalError(struct Hjava_lang_String* msg)
{
	printf("Fatal Error: ");
	printStr(msg, 1);
	exit(1);
}

void edu_utah_janos_nodeos_moab_Node_enablePQ(void)
{
#ifdef DEMO
	pq_enable();
#endif
}

void edu_utah_janos_nodeos_moab_Node_disablePQ(void)
{
#ifdef DEMO
	pq_disable();
#endif
}

void edu_utah_janos_nodeos_moab_Node_enableCPUScheduling(void)
{
#ifdef DEMO
	stride_scheduler_enable();
#endif
}

void edu_utah_janos_nodeos_moab_Node_disableCPUScheduling(void)
{
#ifdef DEMO
	stride_scheduler_disable();
#endif
}

void edu_utah_janos_nodeos_moab_Node_shutdown(void)
{
	printf("Shutting down.\n");
	exit(0);
}

struct Hjava_lang_String* edu_utah_janos_nodeos_moab_Node_hostname(void)
{
	return stringC2Java(an_info_gethostname());
}

struct Hjava_lang_String* edu_utah_janos_nodeos_moab_Node_getHostAddress(void)
{
	NOTIMPLEMENTED("MoabGlueFunction in moab_Node.c");
}
