/*
 * moab_OutChannel.c
 *
 * Copyright (c) 2000, 2001, 2002 The University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is licensed under the terms of the GNU Public License.  
 * See the file "license.terms" for restrictions on redistribution 
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */

#include <stdlib.h>

#include <nodeos/an_impl.h>
#include <nodeos/an_chan.h>

#include "../../../../kaffe/kaffevm/gtypes.h"
#include "../../../../kaffe/kaffevm/thread.h"
#include "../../../../kaffe/kaffevm/stringSupport.h"

#include "moabglue.h"

struct Hedu_utah_janos_nodeos_DeliverFunc; // XXX
struct Hedu_utah_janos_nodeos_moab_Domain;
struct Hedu_utah_janos_nodeos_moab_BufferHandle;
struct Hedu_utah_janos_nodeos_moab_InChannel;
#include "edu_utah_janos_nodeos_moab_OutChannel.h"

jint edu_utah_janos_nodeos_moab_OutChannel_init(struct Hedu_utah_janos_nodeos_moab_OutChannel* this,
						struct Hedu_utah_janos_nodeos_moab_Domain* domain,
						jint bandwidth,
						struct Hjava_lang_String* protoSpec,
						struct Hedu_utah_janos_nodeos_moab_ChannelAddressSpec *cas)
{
	an_netspec_t netspec;
	an_chan_t *rc;
	an_chanproto_t proto;
	an_chanaddr_t *addr;

	assert(sizeof(proto.data) > STRING_SIZE(protoSpec));
	proto.len = STRING_SIZE(protoSpec);
	stringJava2CBuf(protoSpec, proto.data, sizeof(proto.data));

	addr = NATIVE_ADDRSPEC(cas);

	netspec.bandwidth = bandwidth;
	rc = an_outchan_create(NATIVE_OUTCHAN(this),
			       NATIVE_DOMAIN(domain),
			       &proto, addr,
			       &netspec);
	if (rc != NATIVE_OUTCHAN(this))
	{
		assert(rc == NULL);
		panic("error in moab_OutChannel.init(): %s\n", an_error_message());
	}

	return 0;
}

jboolean edu_utah_janos_nodeos_moab_OutChannel_send(struct Hedu_utah_janos_nodeos_moab_OutChannel* this,
						    struct Hedu_utah_janos_nodeos_moab_BufferHandle* buf)
{
	int rc;
	
	while (an_pbuf_isbusy(NATIVE_PBUF(buf)))
		yieldThread();
	rc = an_outchan_send(NATIVE_OUTCHAN(this),
			     NATIVE_PBUF(buf));

	return (rc == 0);
}

void edu_utah_janos_nodeos_moab_OutChannel_sendAndRecycle(struct Hedu_utah_janos_nodeos_moab_OutChannel* this,
							  struct Hedu_utah_janos_nodeos_moab_BufferHandle* buf,
							  struct Hedu_utah_janos_nodeos_moab_InChannel* ichan)
{
	NOTIMPLEMENTED("MoabGlueFunction in moab_OutChannel.c");
}

void edu_utah_janos_nodeos_moab_OutChannel_sendAsynch(struct Hedu_utah_janos_nodeos_moab_OutChannel* this,
						      struct Hedu_utah_janos_nodeos_moab_BufferHandle* buf,
						      struct Hedu_utah_janos_nodeos_DeliverFunc* df)
{
	NOTIMPLEMENTED("MoabGlueFunction in moab_OutChannel.c");
}

void edu_utah_janos_nodeos_moab_OutChannel_sendv(struct Hedu_utah_janos_nodeos_moab_OutChannel* this,
						 HArrayOfObject* bufs)
{
	NOTIMPLEMENTED("MoabGlueFunction in moab_OutChannel.c");
}

void
edu_utah_janos_nodeos_moab_OutChannel_getStats(struct Hedu_utah_janos_nodeos_moab_OutChannel* this,
					       struct Hedu_utah_janos_nodeos_moab_ChanStats *cs)
{
	an_error_t err;
	
	err = an_chan_stats(NATIVE_OUTCHAN(this), NATIVE_CHANSTATS(cs));
	assert(err == 0);
}

void edu_utah_janos_nodeos_moab_OutChannel_destroy(struct Hedu_utah_janos_nodeos_moab_OutChannel* this)
{
	NOTIMPLEMENTED("MoabGlueFunction in moab_OutChannel.c");
}

