/*
 * moab_Thread.c
 *
 * Copyright (c) 2000, 2002 The University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is licensed under the terms of the GNU Public License.  
 * See the file "license.terms" for restrictions on redistribution 
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */

#include <stdlib.h>

#include "../../../../kaffe/kaffevm/gtypes.h"
#include "../../../../kaffe/kaffevm/ksem.h"
#include "../../../../kaffe/kaffevm/exception.h"
#include "../../../../kaffe/kaffevm/thread.h"
#include "../../../../kaffe/kaffevm/threadData.h"
#include "../../../../kaffe/kaffevm/systems/nodeos-threads/anjthread_types.h"
#include "../../../../kaffe/kaffevm/systems/nodeos-threads/anjthread_types_priv.h"
#include "../../../../kaffe/kaffevm/systems/nodeos-threads/anjthread_create.h"
#include "../../../../kaffe/kaffevm/systems/nodeos-threads/anjthread_status.h"

#include "moabglue.h"

void edu_utah_janos_nodeos_moab_Thread_setupNativeThreadState(struct Hedu_utah_janos_nodeos_moab_Thread* this,
							      struct Hjava_lang_Thread* jlThread,
							      jint stackSize)
{
	assert((void*)unhand(this)->jlThread == (void*)jlThread);
	
	/* XXX allocates stack */
	anjthread_createpartialthread(NATIVE_THREAD(this),
				      jlThread,
				      stackSize); 
	
	/* XXX do we still need this in JanosVM? */
	unhand(jlThread)->PrivateInfo = (void*)NATIVE_THREAD(this);

#if 0
	/* Allocate the ksem for the jlthread */
	initThreadData(jthread_get_data(NATIVE_THREAD(this)),
		       NATIVE_THREAD(this));
#endif

	/*
	 * Preallocate a stack overflow error for this thread in case
	 * it runs out.
	 */
	unhand(jlThread)->stackOverflowError = 
		(Hjava_lang_Throwable*)StackOverflowError;
	unhand(jlThread)->needOnStack = STACK_HIGH;
}

