/*
 * moab_ThreadPool.c
 *
 * Copyright (c) 2000 The University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is licensed under the terms of the GNU Public License.  
 * See the file "license.terms" for restrictions on redistribution 
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */

#include <stdlib.h>

#include "../../../../kaffe/kaffevm/gtypes.h"
#include "../../../../kaffe/kaffevm/classMethod.h"
#include "../../../../kaffe/kaffevm/thread.h"
#include "moabglue.h"

jint edu_utah_janos_nodeos_moab_ThreadPool_init(struct Hedu_utah_janos_nodeos_moab_ThreadPool* this,
						jint maxThreads,
						jint rate,
						HArrayOfObject* arrayOfMoabThread,
						jint sched,
						jbool explicit)
{
	int i;
	an_cpuspec_t* cpuspec;
	an_thread_t** nativeThreads;

	assert(sched == 0); /* XXX for now */
	assert(maxThreads > 0);

	/* assert(OBJECT_CLASS(arrayOfMoabThread)); */
	/* assert(CLASS_IS_ARRAY(OBJECT_CLASS(arrayOfMoabThread)));*/
	/*assert(CLASS_ELEMENT_TYPE(OBJECT_CLASS(arrayOfMoabThread)) == Hedu_utah_janos_nodeos_moab_Thread);*/

	cpuspec = NATIVE_THREADPOOLSPEC(this);
	if( explicit )
	{
		assert(arrayOfMoabThread);
		/* XXX for now */
		assert(obj_length(arrayOfMoabThread) == maxThreads);
		
		/* XXX doing this malloc is bad. */
		nativeThreads = malloc(sizeof(void*) * maxThreads);
		
		for (i = 0; i < maxThreads; i++)
		{
			Hedu_utah_janos_nodeos_moab_Thread* mth;
			Hjava_lang_Thread *jlth;
			jthread_t anjth;
			
			/*
			 * Each thread was allocated and its initial state
			 * setup in the moab_Thread.setupNativeThreadState()
			 * function.
			 */
			
			/*
			 * Revel in the stupidity of multi-level thread
			 * abstractions: 
			 */
			
			// moab_Thread -> jlThread -> jthread -> an_thread_t
			mth = ((Hedu_utah_janos_nodeos_moab_Thread**)(unhand_array(arrayOfMoabThread)))[i];
			assert(mth);
			
			jlth = (Hjava_lang_Thread*)(unhand(mth)->jlThread);
			assert(jlth);
			
			anjth = (jthread_t)(unhand(jlth)->PrivateInfo);
			assert(anjth);
			
			nativeThreads[i] = &anjth->native_thread;
		}
		cpuspec->ttype = AN_TH_EXPLICIT;
		cpuspec->threads.ex.nthreads = maxThreads;
		cpuspec->threads.ex.threads = nativeThreads;
	}
	else
	{
		cpuspec->ttype = AN_TH_IMPLICIT;
		cpuspec->threads.im.maxthreads = maxThreads;
		cpuspec->threads.im.stacksize = 16384; // XXX
	}
	cpuspec->rate = rate;
	cpuspec->slice.tv_sec = 1; // XXX
	cpuspec->slice.tv_nsec = 0; // XXX
	cpuspec->sched = NULL;

	return 0;
}

void edu_utah_janos_nodeos_moab_ThreadPool_threadStart(struct Hedu_utah_janos_nodeos_moab_ThreadPool* this,
						       struct Hjava_lang_Runnable* r,
						       struct Hjava_lang_String* name)
{
	NOTIMPLEMENTED("MoabGlueFunction in moab_ThreadPool.c");
}

void edu_utah_janos_nodeos_moab_ThreadPool_destroy(struct Hedu_utah_janos_nodeos_moab_ThreadPool* this)
{
	NOTIMPLEMENTED("MoabGlueFunction in moab_ThreadPool.c");
}

jboolean edu_utah_janos_nodeos_moab_ThreadPool_destroyed(struct Hedu_utah_janos_nodeos_moab_ThreadPool* this)
{
	NOTIMPLEMENTED("MoabGlueFunction in moab_ThreadPool.c");
	return 0;
}

