/*
 * moab_ThreadPoolSpec.c
 *
 * Copyright (c) 2000 The University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is licensed under the terms of the GNU Public License.  
 * See the file "license.terms" for restrictions on redistribution 
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */

#include <stdlib.h>

#include "../../../../kaffe/kaffevm/gtypes.h"
#include "../../../../kaffe/kaffevm/classMethod.h"
#include "../../../../kaffe/kaffevm/thread.h"


#include "moabglue.h"

void edu_utah_janos_nodeos_moab_ThreadPoolSpec_init(struct Hedu_utah_janos_nodeos_moab_ThreadPoolSpec* this,
						    jint maxThreads,
						    HArrayOfObject* arrayOfMoabThread,
						    jint sched)
{
	panic("deprecated.");

#if 0
	int i;
	an_cpuspec_t* cpuspec;
	an_thread_t** nativeThreads;

	assert(sched == 0); /* XXX for now */
	assert(maxThreads > 0);
	assert(maxThreads < 10); /* XXX for now */
	assert(arrayOfMoabThread);
	/* assert(OBJECT_CLASS(arrayOfMoabThread)); */
	/* assert(CLASS_IS_ARRAY(OBJECT_CLASS(arrayOfMoabThread)));*/
	assert(obj_length(arrayOfMoabThread) == maxThreads); /* XXX for now */
	/*assert(CLASS_ELEMENT_TYPE(OBJECT_CLASS(arrayOfMoabThread)) == Hedu_utah_janos_nodeos_moab_Thread);*/

	/* XXX doing this malloc is bad. */
	nativeThreads = malloc(sizeof(void*) * maxThreads);


	for (i = 0; i < maxThreads; i++)
	{
		Hedu_utah_janos_nodeos_moab_Thread* mth;
		Hjava_lang_Thread *jlth;
		jthread_t anjth;
		
		/*
		 * Each thread was allocated and its initial state setup
		 * in the moab_Thread.setupNativeThreadState() function.
		 */

		/*
		 * Revel in the stupidity of multi-level thread
		 * abstractions: 
		 */

		// moab_Thread -> jlThread -> jthread -> an_thread_t
		mth = ((Hedu_utah_janos_nodeos_moab_Thread**)(unhand_array(arrayOfMoabThread)))[i];
		assert(mth);

		jlth = (Hjava_lang_Thread*)(unhand(mth)->jlThread);
		assert(jlth);
		
		anjth = (jthread_t)(unhand(jlth)->PrivateInfo);
		assert(anjth);

		nativeThreads[i] = &anjth->native_thread;
	}

	cpuspec = NATIVE_THREADPOOLSPEC(this);
	cpuspec->ttype = AN_TH_EXPLICIT;
	cpuspec->threads.ex.nthreads = maxThreads;
	cpuspec->threads.ex.threads = nativeThreads;
	cpuspec->rate = 10; // XXX 
	cpuspec->slice.tv_sec = 1; // XXX
	cpuspec->slice.tv_nsec = 0; // XXX
	cpuspec->sched = NULL;
#endif /* 0 */
}


jint edu_utah_janos_nodeos_moab_ThreadPoolSpec_getMaxRate()
{
	an_infocpu_t ic;

	an_info_getcpu(&ic);
	return( ic.cps );
}
