/*
 * moab_TimeSpec.c
 *
 * Copyright (c) 2000, 2001 The University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is licensed under the terms of the GNU Public License.  
 * See the file "license.terms" for restrictions on redistribution 
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */

#include <stdlib.h>

#include <nodeos/impl/an_impl.h>

#include "moabglue.h"
#include "edu_utah_janos_nodeos_TimeSpec.h"
#include "edu_utah_janos_nodeos_moab_TimeSpec.h"

void edu_utah_janos_nodeos_moab_TimeSpec_getTime(
	struct Hedu_utah_janos_nodeos_TimeSpec *ts)
{
	an_timespec_t an_ts;

	an_gettime(&an_ts);
	ts->seconds = an_ts.tv_sec;
	ts->nanoseconds = an_ts.tv_nsec;
}

jbool edu_utah_janos_nodeos_moab_TimeSpec_expired(
	struct Hedu_utah_janos_nodeos_TimeSpec *ts)
{
	an_timespec_t an_ts;
	jbool retval = false;

	an_gettime(&an_ts);
	if( (ts->seconds > an_ts.tv_sec) ||
	    (ts->nanoseconds > an_ts.tv_nsec) )
	{
		retval = true;
	}
	return retval;
}
