/*
 * moab_Transports.c
 *
 * Copyright (c) 2000, 2001 The University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is licensed under the terms of the GNU Public License.  
 * See the file "license.terms" for restrictions on redistribution 
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */

#include <stdlib.h>

#include <nodeos/impl/an_impl.h>

#include "moabglue.h"
#include "edu_utah_janos_nodeos_moab_Transports.h"

Hjava_lang_Class *TransportInterfaceClass;
Hjava_lang_Class *EthernetAddressSpecClass;

jint
edu_utah_janos_nodeos_moab_Transports_queryInterfaces(struct Hedu_utah_janos_nodeos_moab_Transports *this)
{
	moabInfoArray *mia = NATIVE_TRANSPORTS(this);
	jint retval = mia->len;

	if( mia->infos == 0 )
	{
		mia->len = 8;
		if( (mia->infos = gc_malloc(mia->len * sizeof(an_infoif_t),
					    GC_ALLOC_FIXED)) )
		{
			an_error_t rc;
			
			rc = an_info_getifs(mia->infos, &mia->len);
			assert(rc == 0);
			retval = mia->len;
		}
	}
	return retval;
}

struct Hedu_utah_janos_nodeos_moab_TransportInterface *
edu_utah_janos_nodeos_moab_Transports_getInterfaceAt(struct Hedu_utah_janos_nodeos_moab_Transports *this,
						     jint index)
{
	struct Hedu_utah_janos_nodeos_moab_TransportInterface *retval = 0;
	moabInfoArray *mia = NATIVE_TRANSPORTS(this);
	an_infoif_t *info;

	info = &mia->infos[index];
	retval = (struct Hedu_utah_janos_nodeos_moab_TransportInterface *)
		newObject(TransportInterfaceClass);
	retval->name = stringC2Java(info->pname);
	retval->id = info->id;
	switch( info->type )
	{
	case ANIF_ETH:
		retval->address = (struct Hedu_utah_janos_nodeos_AddressSpec *)
			newObject(EthernetAddressSpecClass);
		break;
	default:
		assert(0);
		break;
	}
	*(NATIVE_ADDRSPEC((Hedu_utah_janos_nodeos_moab_ChannelAddressSpec *)
			  retval->address)) = info->addr;
	retval->bandwidth = info->bandwidth;
	retval->physical = true;
	return( retval );
}
