/*
 * moabglue.h
 *
 * Copyright (c) 2000, 2001, 2002 The University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is licensed under the terms of the GNU Public License.  
 * See the file "license.terms" for restrictions on redistribution 
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */

#ifndef _MOABGLUE_H_
#define _MOABGLUE_H_

#include <stdio.h>

#include <nodeos/an_info.h>
#include <nodeos/an_domain.h>
#include <nodeos/an_chan.h>
#include <nodeos/an_cred.h>
#include <nodeos/an_resource.h>
#include <nodeos/an_debug.h>

#include <native.h>
#include <kaffevm/classMethod.h>

struct Hjava_lang_Object; // XXX
struct Hjava_lang_Runnable; // XXX
struct Hjava_lang_Class; // XXX
struct Hjava_lang_Thread; // XXX
struct Hjava_lang_StringBuffer; // XXX
struct _jthread; // XXX

struct Hjava_lang_Object*
newObjectChecked(struct Hjava_lang_Class*,
		 struct _errorInfo *);

struct Hedu_utah_janos_nodeos_DeliverFunc; // XXX


/* Need struct definitions to resolve circular references between types. */
struct Hedu_utah_janos_nodeos_ChanStats;
struct Hedu_utah_janos_nodeos_NetworkSpec;
struct Hedu_utah_janos_nodeos_moab_Domain;
struct Hedu_utah_janos_nodeos_moab_MemSpec;
struct Hedu_utah_janos_nodeos_moab_ChanStats;
struct Hedu_utah_janos_nodeos_moab_Credentials;
struct Hedu_utah_janos_nodeos_moab_ThreadPoolSpec;
struct Hedu_utah_janos_nodeos_moab_BufferHandle;
struct Hedu_utah_janos_nodeos_moab_ChannelAddressSpec;
struct Hedu_utah_janos_nodeos_moab_Credentials;
struct Hedu_utah_janos_nodeos_moab_CutThroughChannel;
struct Hedu_utah_janos_nodeos_moab_Debug;
struct Hedu_utah_janos_nodeos_moab_DemultiplexKey;
struct Hedu_utah_janos_nodeos_moab_EthernetAddressSpec;
struct Hedu_utah_janos_nodeos_moab_Domain;
struct Hedu_utah_janos_nodeos_moab_DomainStats;
struct Hedu_utah_janos_nodeos_moab_Node;
struct Hedu_utah_janos_nodeos_moab_InChannel;
struct Hedu_utah_janos_nodeos_moab_IPAddressSpec;
struct Hedu_utah_janos_nodeos_moab_MemSpec;
struct Hedu_utah_janos_nodeos_moab_OutChannel;
struct Hedu_utah_janos_nodeos_moab_Setup;
struct Hedu_utah_janos_nodeos_moab_Thread;
struct Hedu_utah_janos_nodeos_moab_ThreadPool;
struct Hedu_utah_janos_nodeos_moab_ThreadPoolSpec;
struct Hedu_utah_janos_nodeos_moab_Transports;
struct Hedu_utah_janos_nodeos_moab_TransportInterface;

#include "edu_utah_janos_nodeos_moab_Domain.h"
#include "edu_utah_janos_nodeos_moab_Node.h"
#include "edu_utah_janos_nodeos_moab_ChanStats.h"
#include "edu_utah_janos_nodeos_moab_MemSpec.h"
#include "edu_utah_janos_nodeos_moab_Credentials.h"
#include "edu_utah_janos_nodeos_moab_ThreadPoolSpec.h"
#include "edu_utah_janos_nodeos_moab_BufferHandle.h"
#include "edu_utah_janos_nodeos_moab_ChannelAddressSpec.h"
#include "edu_utah_janos_nodeos_moab_Credentials.h"
#include "edu_utah_janos_nodeos_moab_CutThroughChannel.h"
#include "edu_utah_janos_nodeos_moab_Debug.h"
#include "edu_utah_janos_nodeos_moab_DemultiplexKey.h"
#include "edu_utah_janos_nodeos_moab_EthernetAddressSpec.h"
#include "edu_utah_janos_nodeos_moab_Domain.h"
#include "edu_utah_janos_nodeos_moab_DomainStats.h"
#include "edu_utah_janos_nodeos_moab_InChannel.h"
#include "edu_utah_janos_nodeos_moab_IPAddressSpec.h"
#include "edu_utah_janos_nodeos_moab_MemSpec.h"
#include "edu_utah_janos_nodeos_moab_OutChannel.h"
#include "edu_utah_janos_nodeos_moab_Setup.h"
#include "edu_utah_janos_nodeos_moab_Thread.h"
#include "edu_utah_janos_nodeos_moab_ThreadPool.h"
#include "edu_utah_janos_nodeos_moab_ThreadPoolSpec.h"
#include "edu_utah_janos_nodeos_moab_Transports.h"
#include "edu_utah_janos_nodeos_moab_TransportInterface.h"


#define __UNUSED__ __attribute__((__unused__))

#define NOTIMPLEMENTED(msg) {						\
	errorInfo ei;							\
	postExceptionMessage(&ei, "java.lang.Error", 			\
			     "moabglue: have not implemented %s.",	\
			     __FUNCTION__);				\
	throwError(&ei); \
}


#define DEFINE_NATIVE_CONVERTER(NAME, KAFFETYPE, NODEOSTYPE)	\
static inline NODEOSTYPE*					\
NATIVE_##NAME(KAFFETYPE* jarg) __UNUSED__;			\
static inline KAFFETYPE*					\
KAFFE_##NAME(NODEOSTYPE* jarg) __UNUSED__;			\
 \
static inline NODEOSTYPE*					\
NATIVE_##NAME(KAFFETYPE* jarg)					\
{								\
	void* jobj = (void*)jarg;				\
	void* cobj = jobj + sizeof(KAFFETYPE);			\
								\
	assert(jarg);						\
	assert(jobj);						\
	assert(cobj);						\
	assert(((KAFFETYPE*)jobj));				\
	assert(((KAFFETYPE*)jobj)->base.dtable != NULL);	\
	assert(((KAFFETYPE*)jobj)->base.dtable->class->bfsize >= sizeof(NODEOSTYPE));	\
	return ((NODEOSTYPE*)cobj);				\
}\
static inline KAFFETYPE*					\
KAFFE_##NAME(NODEOSTYPE* carg)					\
{								\
	void* cobj = (void*)carg;				\
	void* jobj = cobj - sizeof(KAFFETYPE);			\
								\
	assert(carg);						\
	assert(cobj);						\
	assert(((KAFFETYPE*)jobj));				\
	assert(((KAFFETYPE*)jobj)->base.dtable != NULL);	\
	return ((KAFFETYPE*)jobj);				\
}\

#if 0
	assert(((KAFFETYPE*)jobj)->base.dtable->class != NULL);	\
	assert(((KAFFETYPE*)jobj)->base.dtable->class->fsize > sizeof(KAFFETYPE));	\
	assert(((KAFFETYPE*)jobj)->base.dtable->class != NULL);	\
	assert(((KAFFETYPE*)jobj)->base.dtable->class->fsize > sizeof(KAFFETYPE));	\


#endif


DEFINE_NATIVE_CONVERTER(DOMAIN, 
			struct Hedu_utah_janos_nodeos_moab_Domain, 
			an_domain_t)

DEFINE_NATIVE_CONVERTER(DOMAINSTATS, 
			struct Hedu_utah_janos_nodeos_moab_DomainStats,
			an_domainstats_t)

DEFINE_NATIVE_CONVERTER(CHANSTATS, 
			struct Hedu_utah_janos_nodeos_moab_ChanStats,
			an_chanstats_t)

DEFINE_NATIVE_CONVERTER(CRED, 
			struct Hedu_utah_janos_nodeos_moab_Credentials, 
			an_cred_t)

DEFINE_NATIVE_CONVERTER(THREADPOOLSPEC, 
			struct Hedu_utah_janos_nodeos_moab_ThreadPool, 
			an_cpuspec_t)
/*
 *DEFINE_NATIVE_CONVERTER(THREADPOOLSPEC, 
 *			struct Hedu_utah_janos_nodeos_moab_ThreadPoolSpec, 
 *			an_cpuspec_t)
 */

DEFINE_NATIVE_CONVERTER(THREAD, 
			struct Hedu_utah_janos_nodeos_moab_Thread, 
			struct _jthread)

DEFINE_NATIVE_CONVERTER(MEMSPEC, 
			struct Hedu_utah_janos_nodeos_moab_MemSpec, 
			an_memspec_t)

DEFINE_NATIVE_CONVERTER(OUTCHAN, 
			struct Hedu_utah_janos_nodeos_moab_OutChannel, 
			an_chan_t)

typedef struct _moabInChannelData {
	an_chan_t chan;
	struct Hedu_utah_janos_nodeos_DeliverFunc *javaCallBack;
	jmethodID runmethod;
} moabInChannelData;

DEFINE_NATIVE_CONVERTER(INCHAN, 
			struct Hedu_utah_janos_nodeos_moab_InChannel, 
			moabInChannelData)

DEFINE_NATIVE_CONVERTER(CUTCHAN, 
			struct Hedu_utah_janos_nodeos_moab_CutThroughChannel, 
			an_chan_t)

DEFINE_NATIVE_CONVERTER(DEMUXKEY, 
			struct Hedu_utah_janos_nodeos_moab_DemultiplexKey, 
			an_demuxkey_t)

DEFINE_NATIVE_CONVERTER(PBUF,
			struct Hedu_utah_janos_nodeos_moab_BufferHandle, 
			an_pbuf_t)

DEFINE_NATIVE_CONVERTER(ADDRSPEC,
			struct Hedu_utah_janos_nodeos_moab_ChannelAddressSpec, 
			an_chanaddr_t)

typedef struct {
	an_infoif_t *infos;
	int len;
} moabInfoArray;

DEFINE_NATIVE_CONVERTER(TRANSPORTS,
			struct Hedu_utah_janos_nodeos_moab_Transports, 
			moabInfoArray)

static inline void notUsedWarningHackSockStuffer(void) __UNUSED__;

static inline void notUsedWarningHackSockStuffer(void) 
{
	checkPtr((void*)NULL);
}

/*
 * AddModule: moabModule
 *   Comment: Add the native data space to our classes.
 */

#endif /* _MOABGLUE_H_ */
