/*
 * Importable.java
 * Base class for objects imported into teams.
 *
 * Copyright (c) 2002 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * This file is licensed under the terms of the GNU Lesser 
 * General Public License.
 * 
 * See the file "license-lesser.terms" for information on 
 * usage and redistribution of this file.
 */
package java.lang;

/*
 * XXX This is kinda stupid, we want to be able to wait on objects in
 * different teams, but we don't want the thread class to be exempt from the
 * write barrier.  So, we have a separate class that is exempt to store the
 * waited on objects in.
 */
class ThreadObjectHolder
{
    Object obj;
    
    ThreadObjectHolder()
    {
    }
    
    public String toString()
    {
	return "ThreadObjectHolder[obj="
	    + this.obj
	    + "]";
    }
}
