/*
 * StdinInputStream.java
 * Input stream for a team's standard in.
 *
 * Copyright (c) 2000, 2001, 2002 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * This file is licensed under the terms of the GNU Lesser 
 * General Public License.
 * 
 * See the file "license-lesser.terms" for information on 
 * usage and redistribution of this file.
 */

package edu.utah.janosvm.io;

import java.io.InputStream;

/**
 * Input stream for a team's standard in.
 * <p>
 * XXX rename to StdInputStream.
 *
 * @author Tim Stack, <a href="mailto:janos-discuss@flux.cs.utah.edu">Utah Janos Team</a>
 */
public class StdinInputStream
    extends InputStream
{

    static
    {
	/* We depend on the IO library */
	System.loadLibrary("io");
    }

    /**
     * Native function that does the actual read from stdin as setup for the
     * current team.
     */
    private native int readInt();

    /**
     * XXX stupid wrapper for the private and native readInt function.
     *
     * @return The byte read or -1 if the end of file was reached.
     */
    public int read()
    {
	return this.readInt();
    }

    /**
     * Native function that does a block read from stdin as setup for the
     * current team.
     *
     * @param b The buffer to read into.
     * @param off The offset into `b' to start writing data.
     * @param len The length of data to read.
     * @return The number of bytes actually read.
     */
    public native int read(byte b[], int off, int len);

    public String toString()
    {
	return "StdinInputStream["
	    + super.toString()
	    + "]";
    }
}
