/*
 * ConfigSpec.java
 * Resource specification for config files.
 *
 * Copyright (c) 2001 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * This file is licensed under the terms of the GNU Lesser 
 * General Public License.
 * 
 * See the file "license-lesser.terms" for information on 
 * usage and redistribution of this file.
 */

package edu.utah.janosvm.resources;

public final class ConfigSpec
    extends ResourceSpec
    implements Cloneable
{
    private native void nativeConstructor(String files[]);

    public ConfigSpec(String files[])
    {
	this.nativeConstructor(files);
    }

    public native int getFileCount();

    public native String getFile(int index);
    
    private native void nativeFinalize();

    public void finalize()
    {
	this.nativeFinalize();
    }

    public static native ConfigSpec current();

    public String toString()
    {
	int count = this.getFileCount();
	String retval =
	    "ConfigSpec[files[" +
	    count +
	    "]={ ";
	int lpc;

	for( lpc = 0; lpc < count; lpc++ )
	{
	    retval += this.getFile(lpc) + " ";
	}
	retval += "}";
	return retval;
    }

    public native Object clone();
}
