/*
 * DuplicateResourceSpecException.java
 * Exception indicating that there was a duplicate resource spec in the array
 * of ResourceSpec's passed to Team.create().
 *
 * Copyright (c) 2002 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * This file is licensed under the terms of the GNU Lesser 
 * General Public License.
 * 
 * See the file "license-lesser.terms" for information on 
 * usage and redistribution of this file.
 */

package edu.utah.janosvm.resources;

/**
 * Exception indicating that there was a duplicate resource spec in the array
 * of ResourceSpec's passed to Team.create().
 *
 * @author Tim Stack, <a href="mailto:janos-discuss@flux.cs.utah.edu">Utah Janos Team</a>
 */
public class DuplicateResourceSpecException
    extends ResourceSpecException
{
    public DuplicateResourceSpecException()
    {
    }
    
    public DuplicateResourceSpecException(String msg)
    {
	super(msg);
    }
}
