/*
 * DeadTeamException.java
 * Exception thrown when a visit cannot be done because one of the teams
 * involved is dead.
 *
 * Copyright (c) 2000, 2001 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * This file is licensed under the terms of the GNU Lesser 
 * General Public License.
 * 
 * See the file "license-lesser.terms" for information on 
 * usage and redistribution of this file.
 */

package edu.utah.janosvm.sys;

/**
 * Exception thrown when a visit cannot be done because one of the teams
 * involved is dead.
 *
 * @author Tim Stack, <a href="mailto:janos-discuss@flux.cs.utah.edu">Utah Janos Team</a>
 */
public class DeadTeamException
    extends Exception
{
    public DeadTeamException()
    {
	super();
    }

    public DeadTeamException(String s)
    {
	super(s);
    }
}
