/*
 * TeamEjectionException.java
 * Exception thrown when a thread is forcefully thrown from a team.
 *
 * Copyright (c) 2001 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * This file is licensed under the terms of the GNU Lesser 
 * General Public License.
 * 
 * See the file "license-lesser.terms" for information on 
 * usage and redistribution of this file.
 */

package edu.utah.janosvm.sys;

/**
 * Exception thrown when a thread is forcefully thrown from a team.
 *
 * @author Tim Stack, <a href="mailto:janos-discuss@flux.cs.utah.edu">Utah Janos Team</a>
 */
public final class TeamEjectionException
    extends Exception
{
    public TeamEjectionException()
    {
	super();
    }

    public TeamEjectionException(String msg)
    {
	super(msg);
    }
}
