/*
 * TeamListHandler.java
 * An interface for TeamList call backs.
 *
 * Copyright (c) 2001, 2002 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * This file is licensed under the terms of the GNU Lesser 
 * General Public License.
 * 
 * See the file "license-lesser.terms" for information on 
 * usage and redistribution of this file.
 */

package edu.utah.janosvm.sys;

/**
 * An interface for TeamList call backs.
 */
public interface TeamListHandler
{
    /**
     * Callback for handling events related to teams.  NOTE: This is called in
     * the context of the kernel so you must use the provided TeamReservation
     * if you want to do anything in the Importables team.
     *
     * @param tr A TeamReservation thats reserved the team that `this' is in.
     * @param ev The TeamEvent object that describes the event that occurred.
     */
    void event(TeamReservation tr, TeamEvent ev);
}
