/*
 * JSIConnectionHandler.java
 *
 * Copyright (c) 2001 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * This file is licensed under the terms of the GNU Lesser 
 * General Public License.
 * 
 * See the file "license-lesser.terms" for information on 
 * usage and redistribution of this file.
 */

package edu.utah.janosvm.kit.comm.jsi;

/**
 * Defines a callback to be used when a new connection is made.
 */
public interface JSIConnectionHandler
{
    /**
     * Handle a new connection to a provider.
     *
     * @param jp The provider that received the connection request.
     * @param jc The connected channel.
     */
    void handle(JSIProvider jp, JSIChannel jc);
}
