/*
 * JSIProvider.java
 *
 * Copyright (c) 2001 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * This file is licensed under the terms of the GNU Lesser 
 * General Public License.
 * 
 * See the file "license-lesser.terms" for information on 
 * usage and redistribution of this file.
 */

package edu.utah.janosvm.kit.comm.jsi;

/**
 * Interface for objects that can provide access to JSI enabled applications.
 */
public interface JSIProvider
{
    /**
     * Detach from whatever rendezvous point is in use.
     */
    void detach();

    /**
     * The main loop of the provider.  Any connections it receives will
     * be handed off to the JSIConnectionHandler.
     *
     * @param jch The handler to call when a new connection is received.
     */
    void handle(JSIConnectionHandler jch);
}
