/*
 * ObjectSparseArrayElement.java
 *
 * Copyright (c) 2001 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * This file is licensed under the terms of the GNU Lesser 
 * General Public License.
 * 
 * See the file "license-lesser.terms" for information on 
 * usage and redistribution of this file.
 */

package edu.utah.janosvm.kit.util;

/**
 * The default SparseArrayElement implementation.
 */
public final class ObjectSparseArrayElement
    extends SparseArrayElement
{
    /**
     * Some arbitrary value.
     */
    private Object value;

    /**
     * @param value The element's value.
     */
    public void setValue(Object value)
    {
	this.value = value;
    }

    /**
     * @return The elements value.
     */
    public Object getValue()
    {
	return this.value;
    }

    protected void dropped()
    {
	this.value = null;
    }

    public String toString()
    {
	return "ObjectSparseArrayElement["
	    + super.toString()
	    + "; value="
	    + this.value
	    + "]";
    }
}
