#
# Copyright (c) 2001 The University of Utah and the Flux Group.
# All rights reserved.
# 
# This file is part of the JanosVM documentation.
# 
# Permission to use, copy, modify, distribute, and sell this
# documentation for any purpose is hereby granted without fee,
# provided that the above copyright notice(s) appear in all copies.
#
# Author: Tim Stack
#

from janosvm import *

class ClassPath:
    def __init__(self, jvm):
        self.jvm = jvm
        self.jvm.msg.pushSpecifier("classpath")

    def get(self):
        self.jvm.msg.setWhat(JSI_GET_PROPERTY)
        reply = self.jvm.send()
        lpc = 0
        count = reply.identifierCount("result")
        retval = []
        while lpc < count:
            if string.atoi(reply.find("resultHidden", lpc)) == 0:
                retval.append(reply.find("result", lpc))
            lpc = lpc + 1
        return retval
    
    def add(self, path):
        self.jvm.msg.setWhat(JSI_EXECUTE_PROPERTY)
        self.jvm.msg.pushSpecifier("add")
        self.jvm.msg.add("path", path)
        reply = self.jvm.send()
        return string.atoi(reply.find("result"))

    def hide(self, path):
        self.jvm.msg.setWhat(JSI_EXECUTE_PROPERTY)
        self.jvm.msg.pushSpecifier("hide")
        self.jvm.msg.add("path", path)
        reply = self.jvm.send()
        return string.atoi(reply.find("result"))

    def remove(self, path):
        self.jvm.msg.setWhat(JSI_EXECUTE_PROPERTY)
        self.jvm.msg.pushSpecifier("remove")
        self.jvm.msg.add("path", path)
        reply = self.jvm.send()
        return string.atoi(reply.find("result"))
