
import edu.utah.janosvm.sys.TeamHandle;
import edu.utah.janosvm.sys.Team;
import edu.utah.janosvm.sys.DeadTeamException;

import edu.utah.janosvm.resources.GCPolicy;
import edu.utah.janosvm.resources.StdioSpec;
import edu.utah.janosvm.resources.MemorySpec;
import edu.utah.janosvm.resources.ResourceSpec;
import edu.utah.janosvm.resources.NameSpaceSpec;
import edu.utah.janosvm.resources.MemoryResource;

public class MemoryPolicy
{

    /* A custom GCPolicy for the team we'll be creating */
    public static class MyGCPolicy
	extends GCPolicy
    {
	public MyGCPolicy(long max)
	{
	    /* Max memory for the team */
	    super(max);
	}
	
	public long initialTrigger()
	{
	    return this.max / 4;
	}

	public long newTrigger(long used, long freed)
	{
	    /* Keep a constant trigger size, this is kinda silly. */
	    return this.max / 4;
	}

    }

    public static void main(String args[])
    {
	try
	{
	    main2(args);
	}
	catch(Throwable e)
	{
	    System.out.println("Exception: " + e);
	    e.printStackTrace();
	}
    }
    
    public static void main2(String args[])
	throws Exception
    {
	Team lt = Team.current();
	ResourceSpec specs[] = {
	    new MemorySpec(8 * 1024 * 1024, MyGCPolicy.class.getName()),
	    StdioSpec.currentFD(),
	    NameSpaceSpec.current()
	};
	TeamHandle child = Team.create("Child of "
				       + lt.getName()
				       + lt.getID(),
				       specs);

	child.switchTo();
	{
	    System.out.println("Testing GCPolicy");
	    try
	    {
		/* Uh... I forgot the point of this test */
		byte tmp[] = new byte[1 * 1024 * 1024];
		Object root[] = { null };
		int lpc;
		
		for( lpc = 0; lpc < 3; lpc++ )
		{
		    root[0] = new byte[1 * 1024 * 1024];
		    root[0] = null;
		}
	    }
	    catch(OutOfMemoryError oom)
	    {
		System.out.println("Memory policy failed");
	    }
	}
	child.returnFrom();
	child.terminate();
	
    }
    
}

/* Expected Output:
Testing GCPolicy
*/
