
import edu.utah.janosvm.sys.Team;
import edu.utah.janosvm.sys.TeamHandle;
import edu.utah.janosvm.sys.TeamReservation;

import edu.utah.janosvm.resources.StdioSpec;
import edu.utah.janosvm.resources.NativeSpec;
import edu.utah.janosvm.resources.ResourceSpec;

public class NativeTest
{
	public static void main(String args[])
		throws Exception
	{
		Team team = Team.current();
		TeamReservation tr;
		TeamHandle th;
		NativeSpec ns;

		ns = new NativeSpec(null);
		if( ns.getPathCount() != 0 )
		    System.out.println("Theres something in an empty spec?");
		if( ns.getPath(0) != null )
		    System.out.println("Theres something in an empty spec?");
		try
		{
			System.loadLibrary("io");
			System.out.println("Able to access native lib?");
		}
		catch(UnsatisfiedLinkError e)
		{
			System.out.println("Can't get access to native lib");
		}
		{
			NativeSpec kernSpec;
			
			th = team.getKernelTeam();
			tr = th.pushReservation();
			tr.visit();
			{
				kernSpec = NativeSpec.current();
			}
			tr.leave();
			ns = (NativeSpec)kernSpec.clone();
			kernSpec = null;
			tr.pop();
		}
		if( ns.getPathCount() == 0 )
		    System.out.println("Kernel native path is empty?");
		th = Team.create("Child of NativeTest " +
				 team.getID(),
				 new ResourceSpec[] {
					 StdioSpec.currentFD(),
					 ns
				 });
		th.switchTo();
		{
			try
			{
				System.loadLibrary("kaffejanosvm");
				System.out.println("Able to access native lib"
						   + " in privileged team");
			}
			catch(UnsatisfiedLinkError e)
			{
				System.out.println("Can't get access to "
						   + "native lib in "
						   + "privileged team?");
				e.printStackTrace();
			}
		}
		th.returnFrom();
		th.terminate();
	}
}

/* Expected Output:
Can't get access to native lib
Able to access native lib in privileged team
*/
