
import edu.utah.janosvm.sys.TeamHandle;
import edu.utah.janosvm.sys.Team;
import edu.utah.janosvm.sys.Importable;
import edu.utah.janosvm.sys.Exportable;
import edu.utah.janosvm.sys.DeadTeamException;
import edu.utah.janosvm.sys.NoSuchExportException;

public class RevokeExport
{

    /* The object we'll be exporting */
    private static class IntegerExport
	extends Exportable
    {
	private int value;

	public IntegerExport(int iValue)
	{
	    this.value = iValue;
	}
    }

    /* The object that imports the above Exportable */
    private static class IntegerImport
	extends Importable
    {
	public IntegerExport ie;
	
	protected void bindTo(Exportable ex)
	{
	    this.ie = (IntegerExport)ex;
	}

	protected void unbindFrom()
	{
	    this.ie = null;
	}
    }
    
    public static void main(String args[])
	throws Exception
    {
	IntegerExport ie = new IntegerExport(1);
	IntegerImport ii = new IntegerImport();
	Team team = Team.current();

	/* Export our object */
	team.exportObject("i", ie);
	/* Attach the import */
	team.importObject(ii, "i");
	/* Make sure its the same thing */
	if( ii.ie == ie )
	{
	    System.out.println("Got export");
	}
	else
	{
	    System.out.println("Didn't get export");
	}
	/* Revoke it */
	team.revokeObject("i");
	/* Make sure its not accessible anymore */
	if( ii.ie == null )
	{
	    System.out.println("Import revoked");
	}
	else
	{
	    System.out.println("Import still available");
	}
	try
	{
	    team.importObject(ii, "i");
	}
	catch(NoSuchExportException nsee)
	{
	    System.out.println("Can't import it again");
	}
    }
    
}

/* Expected Output:
Got export
Import revoked
Can't import it again
*/
