
import edu.utah.janosvm.kit.util.SharedTableWriter;
import edu.utah.janosvm.kit.util.SharedTableReader;

public class SharedTableTest
{
    public static SharedTableReader reader;
    
    public static void main(String args[])
    {
	SharedTableWriter tw = new SharedTableWriter();
	Object value;
	
	SharedTableTest.reader = tw.getReader();
	if( reader.get("one") != null )
	{
	    System.out.println("Found something in an empty table?");
	}
	tw.put("one", value = new Integer(1));
	if( (value == reader.get("one")) || (value == tw.get("one")) )
	{
	    System.out.println("Found `one'");
	}
	tw.sync(true);
	if( (value == reader.get("one")) || (value == tw.get("one")) )
	{
	    System.out.println("Found `one' after sync");
	}
	tw.remove("one");
	tw.sync();
	if( (value == reader.get("one")) || (value == tw.get("one")) )
	{
	    System.out.println("Found `one' after it was removed? "
			       + reader.get("one")
			       + " "
			       + tw.get("one"));
	}

	final int COUNT = 1000;
	int lpc;

	tw = new SharedTableWriter();
	SharedTableTest.reader = tw.getReader();
	for( lpc = 0; lpc < COUNT; lpc++ )
	{
	    tw.put(new Integer(lpc), new Integer(COUNT + lpc));
	}
	tw.sync(true);
	for( lpc = 0; lpc < COUNT; lpc++ )
	{
	    Integer i = (Integer)reader.get(new Integer(lpc));

	    if( i == null )
	    {
		System.out.println("Couldn't find association for " + lpc);
	    }
	    else if( ((Integer)reader.get(new Integer(lpc))).intValue() !=
		     (COUNT + lpc) )
	    {
		System.out.println("Bad association for " + lpc);
	    }
	}
	for( lpc = 0; lpc < COUNT; lpc++ )
	{
	    if( (lpc % 2) == 0 )
	    {
		tw.remove(new Integer(lpc));
	    }
	}
	tw.sync(true);
	for( lpc = 0; lpc < COUNT; lpc++ )
	{
	    if( (lpc % 2) == 0 )
	    {
	    }
	    else if( reader.get(new Integer(lpc)) == null )
	    {
		System.out.println("Lost association for " + lpc);
	    }
	}
    }
}

/* Expected Output:
Found `one'
Found `one' after sync
*/
