
import edu.utah.janosvm.sys.TeamHandle;
import edu.utah.janosvm.sys.Team;
import edu.utah.janosvm.sys.DeadTeamException;

import edu.utah.janosvm.resources.StdioSpec;
import edu.utah.janosvm.resources.ResourceSpec;

import edu.utah.janosvm.kit.comm.amiga.SignalSet;

public class StalledGeno
{

    private static final int SIG_CONTINUE = 0;
    
    public static void main(String args[])
	throws Exception
    {
	final SignalSet ss = new SignalSet();
	final Team parent = Team.current();

	/* Create a team to visit */
	final TeamHandle child = Team.create("Child of "
					     + parent.getName()
					     + parent.getID(),
					     new ResourceSpec[] {
						     StdioSpec.currentFD()
					     });

	System.out.println("Its pretty hard to speculate how threads "
			   + "react when their team is terminated");
	ss.allocate(SIG_CONTINUE);
	new Thread(new Runnable() {
	    
	    public void run()
	    {
		int lpc;

		/* Synchronize with the main thread */
		ss.signal(SIG_CONTINUE);
		/* Do something for awhile */
		for( lpc = 0; ; lpc++ )
		{
		    System.out.println("Ping #" + lpc);
		    try { Thread.sleep(10); }
		    catch(Exception e) { }
		}
	    }
	    
	}).start();
	child.switchTo();
	{
	    /*
	     * We must get our own since the parent's import will be
	     * revoked below.
	     */
	    Team myself = Team.current();

	    /* Wait for the above thread */
	    ss.waitFor(1L << SIG_CONTINUE);
	    /*
	     * Mark the parent for termination, however, since we're in a visit
	     * it won't be killed until we return.
	     */
	    parent.terminate();
	    /*
	     * The child TeamHandle object is revoked now, so we must use our
	     * local reference to kill ourselves.
	     */
	    myself.terminate();
	    /* Delay for a bit... */
	    ss.waitFor(0, 50);
	}
	child.returnFrom();
	/* The above endVisit should kill the child team and this team */
    }
    
}

/* Expected Output:
*/
