
import edu.utah.janosvm.sys.Team;
import edu.utah.janosvm.sys.TeamHandle;

import edu.utah.janosvm.resources.StdioSpec;
import edu.utah.janosvm.resources.ResourceSpec;

public class StdioTest
{
    public static void main(String args[])
	throws Exception
    {
	Team curr = Team.current();
	TeamHandle child = Team.create(
		"Child of " + curr.getName() + "("  + curr.getID() + ")",
		new ResourceSpec[] {
			new StdioSpec("builtin://none",
				      "file://stdioTest.out",
				      "file://stdioTest.err")
		});
	
	child.switchTo();
	{
	    System.out.println("stdout: Hello, my name is Inigo Montoya");
	    System.err.println("stderr: You killed my father, prepare to die");
	}
	child.returnFrom();
	child.terminate();

	StdioSpec mySpec = StdioSpec.currentFD();
	child = Team.create("Child 2 of "
			    + curr.getName()
			    + "("
			    + curr.getID()
			    + ")",
			    new ResourceSpec[] {
				    new StdioSpec("file://stdioTest.out",
						  mySpec.getOutput(),
						  mySpec.getError())
			    });
	
	child.switchTo();
	{
	    final int len = 1024;
	    byte buf[] = new byte[len];
	    int count;
	    
	    while( (count = System.in.read(buf)) > 0 )
	    {
		System.out.write(buf, 0, count);
	    }
	}
	child.returnFrom();
	child.terminate();
    }
}

/* Expected Output:
stdout: Hello, my name is Inigo Montoya
*/
