
import edu.utah.janosvm.sys.Team;
import edu.utah.janosvm.sys.TeamHandle;
import edu.utah.janosvm.sys.DeadTeamException;

import edu.utah.janosvm.resources.StdioSpec;
import edu.utah.janosvm.resources.ResourceSpec;

public class TeamLocal
{
    
    public static void main(String args[])
	throws Exception
    {
	Team lt = Team.current();

	/* Create a generic new team */
	final TeamHandle child = Team.create("Child of "
					     + lt.getName()
					     + lt.getID(),
					     new ResourceSpec[] {
						     StdioSpec.currentFD()
					     });

	/* Set a class local for the TeamHandle class since its shared */
	lt.setClassLocal(TeamHandle.class, new Integer(0));
	child.switchTo();
	{
	    Team lt2 = Team.current();

	    /* Try to get the class local within this teams context */
	    if( lt2.getClassLocal(TeamHandle.class) != null )
		System.out.println("Found object?");
	    else
		System.out.println("No team object yet");
	    /*
	     * Set a new class local in this team's context to make sure
	     * it doesn't show up in the previous team.
	     */
	    lt2.setClassLocal(TeamHandle.class, new Integer(1));
	}
	child.returnFrom();
	/* Make sure the right object is still there */
	if( ((Integer)lt.getClassLocal(TeamHandle.class)).intValue() != 0 )
	    System.out.println("Wrong object!");
	else
	    System.out.println("Correct team object found!");
	child.terminate();
	/* Make sure class locals are anchored in the GC */
	System.gc();
	System.gc();
	if( ((Integer)lt.getClassLocal(TeamHandle.class)).intValue() == 0 )
	    System.out.println("Object is still alive after gc");
    }
    
}

/* Expected Output:
No team object yet
Correct team object found!
Object is still alive after gc
*/
