
import edu.utah.janosvm.sys.TeamHandle;
import edu.utah.janosvm.sys.Team;
import edu.utah.janosvm.sys.DeadTeamException;

import edu.utah.janosvm.resources.StdioSpec;
import edu.utah.janosvm.resources.ResourceSpec;

public class Visit
{

    public static void main(String args[])
	throws Exception
    {
	final Team parent = Team.current();

	/* Create a team to do some simple visit operations */
	final TeamHandle child = Team.create("Child of "
					     + parent.getName()
					     + parent.getID(),
					     new ResourceSpec[] {
						     StdioSpec.currentFD()
					     });

	child.switchTo();
	{
	    if( Team.current().equals(child) )
	    {
		System.out.println("Visit succeeded");
	    }
	    else
	    {
		System.out.println("Visit failed");
	    }
	}
	child.returnFrom();
	if( Team.current().equals(parent) )
	{
	    System.out.println("endVisit succeeded");
	}
	else
	{
	    System.out.println("endVisit failed");
	}
	child.terminate();
	try
	{
	    child.switchTo();
	    {
		System.out.println("Error: visited child after it was "
				   + "terminated");
	    }
	    child.returnFrom();
	}
	catch(DeadTeamException dte)
	{
	    System.out.println("Unable to visit after termination.");
	}
    }
    
}

/* Expected Output:
Visit succeeded
endVisit succeeded
Unable to visit after termination.
*/
