
import edu.utah.janosvm.sys.Team;
import edu.utah.janosvm.sys.TeamHandle;
import edu.utah.janosvm.sys.DeadTeamException;

import edu.utah.janosvm.resources.StdioSpec;
import edu.utah.janosvm.resources.ResourceSpec;

public class Visit2
{

    public static void main(String args[])
	throws Exception
    {
	final Team parent = Team.current();
	final TeamHandle child = Team.create("Child of "
					     + parent.getName()
					     + parent.getID(),
					     new ResourceSpec[] {
						     StdioSpec.currentFD()
					     });

	child.switchTo();
	{
	    try
	    {
		parent.switchTo();
		{
		    if( Team.current().equals(parent) )
		    {
			System.out.println("Back in parent");
		    }
		}
		parent.returnFrom();
	    }
	    catch(DeadTeamException dte)
	    {
	    }
	    if( Team.current().equals(child) )
	    {
		System.out.println("In Child again");
	    }
	}
	child.returnFrom();
	if( Team.current().equals(parent) )
	{
	    System.out.println("endVisit succeeded");
	}
	else
	{
	    System.out.println("endVisit failed");
	}
	child.terminate();
	try
	{
	    child.switchTo();
	    {
		System.out.println("Error: visited child after it was "
				   + "terminated");
	    }
	    child.returnFrom();
	}
	catch(DeadTeamException dte)
	{
	    System.out.println("Unable to visit after termination.");
	}
    }
    
}

/* Expected Output:
Back in parent
In Child again
endVisit succeeded
Unable to visit after termination.
*/
