
import edu.utah.janosvm.sys.Team;
import edu.utah.janosvm.sys.TeamHandle;
import edu.utah.janosvm.sys.TeamReservation;
import edu.utah.janosvm.sys.DeadTeamException;
import edu.utah.janosvm.sys.TeamEjectionException;

import edu.utah.janosvm.resources.StdioSpec;
import edu.utah.janosvm.resources.ResourceSpec;

public class VisitException
{
    public static void main(String args[])
	throws Exception
    {
	Team lt = Team.current();
	final TeamHandle child = Team.create("Child of "
					     + lt.getName()
					     + "("
					     + lt.getID()
					     + ")",
					     new ResourceSpec[] {
						     StdioSpec.currentFD()
					     });
	
	try
	{
	    /*
	     * Throw an exception while in a visit to make sure we back out
	     * of it and the exception object is copied back into our team.
	     */
	    child.switchTo();
	    {
		throw new NullPointerException();
	    }
	    // child.returnFrom();
	}
	catch(NullPointerException e)
	{
	    if( !lt.owns(e) )
		System.out.println("I don't own the exception?");
	    if( !lt.equals(Team.current()) )
		System.out.println("We're in a different team?");
	    System.out.println("Caught exception thrown in a visit");
	}
	
	TeamReservation ta = child.pushReservation();
	
	try
	{
	    /*
	     * Throw an error while in a TeamReservation use to make sure
	     * we back out of it and the exception object is copied back into
	     * our team.
	     */
	    ta.visit();
	    {
		throw new Error(CloneFactory.clone("Hello"));
	    }
	    // ta.end();
	}
	catch(TeamEjectionException e)
	{
	    System.out.println("egads, wut hoppened?");
	}
	catch(Error e)
	{
	    if( !lt.owns(e) )
		System.out.println("I don't own the error?");
	    if( !lt.owns(e.getMessage()) )
		System.out.println("The Error wasn't deep copied?");
	    if( !e.getMessage().equals("Hello") )
		System.out.println("The Error message is bogus?");
	    if( !lt.equals(Team.current()) )
		System.out.println("We're in a different team?");
	    System.out.println("Caught error thrown from another team");
	}
	TeamHandle.popReservation();

	child.terminate();
    }
    
}

/* Expected Output:
Caught exception thrown in a visit
Caught error thrown from another team
*/
